Index: trunk/src/VBox/Devices/Serial/DevSerial.cpp
===================================================================
--- trunk/src/VBox/Devices/Serial/DevSerial.cpp	(revision 37093)
+++ trunk/src/VBox/Devices/Serial/DevSerial.cpp	(revision 37094)
@@ -278,5 +278,5 @@
         f->count++;
     else if (fifo == XMIT_FIFO) /* need to at least adjust tail to maintain pipe state consistency */
-    	++f->tail;
+        ++f->tail;
     else if (fifo == RECV_FIFO)
         s->lsr |= UART_LSR_OE;
Index: trunk/src/VBox/VMM/VMMR3/PATMA.asm
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PATMA.asm	(revision 37093)
+++ trunk/src/VBox/VMM/VMMR3/PATMA.asm	(revision 37094)
@@ -75,5 +75,5 @@
     DD      PATM_ALLPATCHCALLS
     DD      0
-    DD	    PATM_PERPATCHCALLS
+    DD      PATM_PERPATCHCALLS
     DD      0
     DD      PATM_INTERRUPTFLAG
@@ -124,5 +124,5 @@
     DD      0
     DD      PATMClearPIF_End - PATMClearPIF_Start
-	DD		1
+    DD      1
     DD      PATM_INTERRUPTFLAG
     DD      0
@@ -138,6 +138,6 @@
     pushf
 
-	test	dword [ss:PATM_VMFLAGS], X86_EFL_IF
-	jz		PATMClearInhibitIRQFaultIF0_Fault
+    test    dword [ss:PATM_VMFLAGS], X86_EFL_IF
+    jz      PATMClearInhibitIRQFaultIF0_Fault
 
     ; if interrupts are pending, then we must go back to the host context to handle them!
@@ -177,5 +177,5 @@
     DD      0
     DD      PATMClearInhibitIRQFaultIF0_End - PATMClearInhibitIRQFaultIF0_Start
-	DD		12
+    DD      12
     DD      PATM_INTERRUPTFLAG
     DD      0
@@ -213,6 +213,6 @@
     pushf
 
-	test	dword [ss:PATM_VMFLAGS], X86_EFL_IF
-	jz		PATMClearInhibitIRQContIF0_Continue
+    test    dword [ss:PATM_VMFLAGS], X86_EFL_IF
+    jz      PATMClearInhibitIRQContIF0_Continue
 
     ; if interrupts are pending, then we must go back to the host context to handle them!
@@ -247,5 +247,5 @@
     DD      0
     DD      PATMClearInhibitIRQContIF0_End - PATMClearInhibitIRQContIF0_Start
-	DD		11
+    DD      11
     DD      PATM_INTERRUPTFLAG
     DD      0
@@ -416,11 +416,11 @@
 PATMTrapNoRing1:
 
-	; correct EFLAGS on the stack to include the current IOPL
-	push	eax
-	mov     eax, dword [ss:PATM_VMFLAGS]
-	and     eax, X86_EFL_IOPL
-	and     dword [esp+16], ~X86_EFL_IOPL		; esp+16 = eflags = esp+8+4(efl)+4(eax)
-	or      dword [esp+16], eax
-    pop		eax
+    ; correct EFLAGS on the stack to include the current IOPL
+    push    eax
+    mov     eax, dword [ss:PATM_VMFLAGS]
+    and     eax, X86_EFL_IOPL
+    and     dword [esp+16], ~X86_EFL_IOPL       ; esp+16 = eflags = esp+8+4(efl)+4(eax)
+    or      dword [esp+16], eax
+    pop     eax
 
     popf
@@ -501,11 +501,11 @@
 PATMTrapErrorCodeNoRing1:
 
-	; correct EFLAGS on the stack to include the current IOPL
-	push	eax
-	mov     eax, dword [ss:PATM_VMFLAGS]
-	and     eax, X86_EFL_IOPL
-	and     dword [esp+20], ~X86_EFL_IOPL		; esp+20 = eflags = esp+8+4(efl)+4(error code)+4(eax)
-	or      dword [esp+20], eax
-    pop		eax
+    ; correct EFLAGS on the stack to include the current IOPL
+    push    eax
+    mov     eax, dword [ss:PATM_VMFLAGS]
+    and     eax, X86_EFL_IOPL
+    and     dword [esp+20], ~X86_EFL_IOPL       ; esp+20 = eflags = esp+8+4(efl)+4(error code)+4(eax)
+    or      dword [esp+20], eax
+    pop     eax
 
     popf
@@ -586,11 +586,11 @@
 PATMIntNoRing1:
 
-	; correct EFLAGS on the stack to include the current IOPL
-	push	eax
-	mov     eax, dword [ss:PATM_VMFLAGS]
-	and     eax, X86_EFL_IOPL
-	and     dword [esp+16], ~X86_EFL_IOPL		; esp+16 = eflags = esp+8+4(efl)+4(eax)
-	or      dword [esp+16], eax
-    pop		eax
+    ; correct EFLAGS on the stack to include the current IOPL
+    push    eax
+    mov     eax, dword [ss:PATM_VMFLAGS]
+    and     eax, X86_EFL_IOPL
+    and     dword [esp+16], ~X86_EFL_IOPL       ; esp+16 = eflags = esp+8+4(efl)+4(eax)
+    or      dword [esp+16], eax
+    pop     eax
 
     popf
@@ -668,11 +668,11 @@
 PATMIntNoRing1_ErrorCode:
 
-	; correct EFLAGS on the stack to include the current IOPL
-	push	eax
-	mov     eax, dword [ss:PATM_VMFLAGS]
-	and     eax, X86_EFL_IOPL
-	and     dword [esp+20], ~X86_EFL_IOPL		; esp+20 = eflags = esp+8+4(efl)+4(eax)+4(error code)
-	or      dword [esp+20], eax
-    pop		eax
+    ; correct EFLAGS on the stack to include the current IOPL
+    push    eax
+    mov     eax, dword [ss:PATM_VMFLAGS]
+    and     eax, X86_EFL_IOPL
+    and     dword [esp+20], ~X86_EFL_IOPL       ; esp+20 = eflags = esp+8+4(efl)+4(eax)+4(error code)
+    or      dword [esp+20], eax
+    pop     eax
 
     popf
@@ -1252,15 +1252,15 @@
 
 iret_continue :
-	; This section must *always* be executed (!!)
-	; Extract the IOPL from the return flags, save them to our virtual flags and
-	; put them back to zero
+    ; This section must *always* be executed (!!)
+    ; Extract the IOPL from the return flags, save them to our virtual flags and
+    ; put them back to zero
     ; @note we assume iretd doesn't fault!!!
-	push	eax
-	mov     eax, dword [esp+16]
-	and     eax, X86_EFL_IOPL
-	and     dword [ss:PATM_VMFLAGS], ~X86_EFL_IOPL
-	or      dword [ss:PATM_VMFLAGS], eax
-    pop		eax
-	and		dword [esp+12], ~X86_EFL_IOPL
+    push    eax
+    mov     eax, dword [esp+16]
+    and     eax, X86_EFL_IOPL
+    and     dword [ss:PATM_VMFLAGS], ~X86_EFL_IOPL
+    or      dword [ss:PATM_VMFLAGS], eax
+    pop     eax
+    and     dword [esp+12], ~X86_EFL_IOPL
 
     ; Set IF again; below we make sure this won't cause problems.
@@ -1306,14 +1306,14 @@
     or      dword [esp+8], 1
 
-	; This section must *always* be executed (!!)
-	; Extract the IOPL from the return flags, save them to our virtual flags and
-	; put them back to zero
-	push	eax
-	mov     eax, dword [esp+16]
-	and     eax, X86_EFL_IOPL
-	and     dword [ss:PATM_VMFLAGS], ~X86_EFL_IOPL
-	or      dword [ss:PATM_VMFLAGS], eax
-    pop		eax
-	and		dword [esp+12], ~X86_EFL_IOPL
+    ; This section must *always* be executed (!!)
+    ; Extract the IOPL from the return flags, save them to our virtual flags and
+    ; put them back to zero
+    push    eax
+    mov     eax, dword [esp+16]
+    and     eax, X86_EFL_IOPL
+    and     dword [ss:PATM_VMFLAGS], ~X86_EFL_IOPL
+    or      dword [ss:PATM_VMFLAGS], eax
+    pop     eax
+    and     dword [esp+12], ~X86_EFL_IOPL
 
     ; Clear IF
@@ -2442,12 +2442,12 @@
     mov     dword [ss:PATM_INTERRUPTFLAG], 0
     pushf
-	test	dword [ss:PATM_VMFLAGS], X86_EFL_IF
-	jnz		PATMCheckIF_Safe
-	nop
-
-	; IF=0 -> unsafe, so we must call the duplicated function (which we don't do here)
-	popf
-    mov     dword [ss:PATM_INTERRUPTFLAG], 1
-	jmp     PATMCheckIF_End
+    test    dword [ss:PATM_VMFLAGS], X86_EFL_IF
+    jnz     PATMCheckIF_Safe
+    nop
+
+    ; IF=0 -> unsafe, so we must call the duplicated function (which we don't do here)
+    popf
+    mov     dword [ss:PATM_INTERRUPTFLAG], 1
+    jmp     PATMCheckIF_End
 
 PATMCheckIF_Safe:
@@ -2465,7 +2465,7 @@
     pop     eax
 %endif
-	popf
-    mov     dword [ss:PATM_INTERRUPTFLAG], 1
-	; IF=1 -> we can safely jump back to the original instruction
+    popf
+    mov     dword [ss:PATM_INTERRUPTFLAG], 1
+    ; IF=1 -> we can safely jump back to the original instruction
     DB      0xE9
 PATMCheckIF_Jump:
@@ -2509,16 +2509,16 @@
     mov     dword [ss:PATM_INTERRUPTFLAG], 0
     pushf
-	test	dword [ss:PATM_VMFLAGS], X86_EFL_IF
-	jnz		PATMJumpToGuest_IF1_Safe
-	nop
-
-	; IF=0 -> unsafe, so fault
-	popf
-    mov     dword [ss:PATM_INTERRUPTFLAG], 1
-	PATM_INT3
+    test    dword [ss:PATM_VMFLAGS], X86_EFL_IF
+    jnz     PATMJumpToGuest_IF1_Safe
+    nop
+
+    ; IF=0 -> unsafe, so fault
+    popf
+    mov     dword [ss:PATM_INTERRUPTFLAG], 1
+    PATM_INT3
 
 PATMJumpToGuest_IF1_Safe:
-	; IF=1 -> we can safely jump back to the original instruction
-	popf
+    ; IF=1 -> we can safely jump back to the original instruction
+    popf
     mov     dword [ss:PATM_INTERRUPTFLAG], 1
     DB      0xE9