Index: trunk/src/VBox/Devices/VMMDev/VMMDev.cpp
===================================================================
--- trunk/src/VBox/Devices/VMMDev/VMMDev.cpp	(revision 37210)
+++ trunk/src/VBox/Devices/VMMDev/VMMDev.cpp	(revision 37211)
@@ -2189,10 +2189,8 @@
 {
     VMMDevState *pThis = IVMMDEVPORT_2_VMMDEVSTATE(pInterface);
-    AssertCompile(sizeof(pThis->mouseXAbs) == sizeof(*pAbsX));
-    AssertCompile(sizeof(pThis->mouseYAbs) == sizeof(*pAbsY));
     if (pAbsX)
-        ASMAtomicReadSize(&pThis->mouseXAbs, pAbsX);
+        *pAbsX = ASMAtomicReadS32(&pThis->mouseXAbs); /* why the atomic read? */
     if (pAbsY)
-        ASMAtomicReadSize(&pThis->mouseYAbs, pAbsY);
+        *pAbsY = ASMAtomicReadS32(&pThis->mouseYAbs);
     return VINF_SUCCESS;
 }
@@ -2210,5 +2208,5 @@
     PDMCritSectEnter(&pThis->CritSect, VERR_SEM_BUSY);
 
-    if ((pThis->mouseXAbs == absX) && (pThis->mouseYAbs == absY))
+    if (pThis->mouseXAbs == absX && pThis->mouseYAbs == absY)
     {
         PDMCritSectLeave(&pThis->CritSect);
Index: trunk/src/VBox/HostDrivers/Support/SUPDrv.c
===================================================================
--- trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 37210)
+++ trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 37211)
@@ -5140,6 +5140,5 @@
     if (enmEvent == RTMPEVENT_OFFLINE)
     {
-        RTCPUID idGipMaster;
-        ASMAtomicReadSize(&pDevExt->idGipMaster, &idGipMaster);
+        RTCPUID idGipMaster = ASMAtomicReadU32(&pDevExt->idGipMaster);
         if (idGipMaster == idCpu)
         {
Index: trunk/src/VBox/Runtime/r0drv/mpnotification-r0drv.c
===================================================================
--- trunk/src/VBox/Runtime/r0drv/mpnotification-r0drv.c	(revision 37210)
+++ trunk/src/VBox/Runtime/r0drv/mpnotification-r0drv.c	(revision 37211)
@@ -305,5 +305,5 @@
     /* pick up the list and the spinlock. */
     RTSpinlockAcquire(hSpinlock, &Tmp);
-    ASMAtomicWriteSize(&g_hRTMpNotifySpinLock, NIL_RTSPINLOCK);
+    ASMAtomicWriteHandle(&g_hRTMpNotifySpinLock, NIL_RTSPINLOCK);
     pHead = g_pRTMpCallbackHead;
     g_pRTMpCallbackHead = NULL;
Index: trunk/src/VBox/Runtime/r0drv/powernotification-r0drv.c
===================================================================
--- trunk/src/VBox/Runtime/r0drv/powernotification-r0drv.c	(revision 37210)
+++ trunk/src/VBox/Runtime/r0drv/powernotification-r0drv.c	(revision 37211)
@@ -301,5 +301,5 @@
     /* pick up the list and the spinlock. */
     RTSpinlockAcquire(hSpinlock, &Tmp);
-    ASMAtomicWriteSize(&g_hRTPowerNotifySpinLock, NIL_RTSPINLOCK);
+    ASMAtomicWriteHandle(&g_hRTPowerNotifySpinLock, NIL_RTSPINLOCK);
     pHead = g_pRTPowerCallbackHead;
     g_pRTPowerCallbackHead = NULL;
Index: trunk/src/VBox/Runtime/r3/linux/semeventmulti-linux.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/linux/semeventmulti-linux.cpp	(revision 37210)
+++ trunk/src/VBox/Runtime/r3/linux/semeventmulti-linux.cpp	(revision 37211)
@@ -175,5 +175,5 @@
      * Invalidate the semaphore and wake up anyone waiting on it.
      */
-    ASMAtomicWriteSize(&pThis->u32Magic, RTSEMEVENTMULTI_MAGIC + 1);
+    ASMAtomicWriteU32(&pThis->u32Magic, RTSEMEVENTMULTI_MAGIC + 1);
     if (ASMAtomicXchgS32(&pThis->iState, -1) == 1)
     {
Index: trunk/src/VBox/VMM/VMMR3/VM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/VM.cpp	(revision 37210)
+++ trunk/src/VBox/VMM/VMMR3/VM.cpp	(revision 37211)
@@ -2528,5 +2528,5 @@
         for (PVMREQ pReq = pReqHead; pReq; pReq = pReq->pNext)
         {
-            ASMAtomicUoWriteSize(&pReq->iStatus, VERR_INTERNAL_ERROR);
+            ASMAtomicUoWriteS32(&pReq->iStatus, VERR_INTERNAL_ERROR);
             ASMAtomicWriteSize(&pReq->enmState, VMREQSTATE_INVALID);
             RTSemEventSignal(pReq->EventSem);
@@ -2553,5 +2553,5 @@
             for (PVMREQ pReq = pReqHead; pReq; pReq = pReq->pNext)
             {
-                ASMAtomicUoWriteSize(&pReq->iStatus, VERR_INTERNAL_ERROR);
+                ASMAtomicUoWriteS32(&pReq->iStatus, VERR_INTERNAL_ERROR);
                 ASMAtomicWriteSize(&pReq->enmState, VMREQSTATE_INVALID);
                 RTSemEventSignal(pReq->EventSem);